Index: uspace/lib/uri/uri.h
===================================================================
--- uspace/lib/uri/uri.h	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
+++ uspace/lib/uri/uri.h	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -0,0 +1,64 @@
+/*
+ * Copyright (c) 2013 Martin Sucha
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup uri
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef URI_URI_H_
+#define URI_URI_H_
+
+typedef struct {
+	char *scheme;
+	char *user_info;
+	char *user_credential;
+	char *host;
+	char *port;
+	char *path;
+	char *query;
+	char *fragment;
+} uri_t;
+
+extern uri_t *uri_parse(const char *);
+extern int uri_scheme_parse(const char *, const char **);
+extern bool uri_scheme_validate(const char *);
+extern int uri_percent_parse(const char *, const char **, uint8_t *);
+extern int uri_user_info_parse(const char *, const char **);
+extern bool uri_user_info_validate(const char *);
+extern int uri_port_parse(const char *, const char **);
+extern bool uri_port_validate(const char *);
+extern bool uri_validate(uri_t *);
+extern void uri_destroy(uri_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/audio/hound/audio_device.c
===================================================================
--- uspace/srv/audio/hound/audio_device.c	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ uspace/srv/audio/hound/audio_device.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -162,5 +162,5 @@
 		}
 		audio_pcm_register_event_callback(dev->sess,
-		    device_event_callback, dev);\
+		    device_event_callback, dev);
 
 		/* Fill the buffer first. Fill the first two fragments,
Index: uspace/srv/fs/ext4fs/ext4fs_ops.c
===================================================================
--- uspace/srv/fs/ext4fs/ext4fs_ops.c	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ uspace/srv/fs/ext4fs/ext4fs_ops.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -876,6 +876,4 @@
 	if (rc != EOK)
 		return rc;
-	if (NULL == inst)
-		return ENOENT;
 
 	ext4_superblock_t *sb = inst->filesystem->superblock;
Index: uspace/srv/fs/mfs/mfs.h
===================================================================
--- uspace/srv/fs/mfs/mfs.h	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ uspace/srv/fs/mfs/mfs.h	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -44,4 +44,5 @@
 #include <errno.h>
 #include <assert.h>
+#include <stdbool.h>
 #include "../../vfs/vfs.h"
 
@@ -105,4 +106,14 @@
 	unsigned isearch;
 	unsigned zsearch;
+
+	/* Indicates wether if the cached number of free zones
+	 * is to be considered valid or not.
+	 */
+	bool nfree_zones_valid;
+	/* Cached number of free zones, used to avoid to scan
+	 * the whole bitmap every time the mfs_free_block_count()
+	 * is invoked.
+	 */
+	unsigned nfree_zones;
 };
 
Index: uspace/srv/fs/mfs/mfs_balloc.c
===================================================================
--- uspace/srv/fs/mfs/mfs_balloc.c	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ uspace/srv/fs/mfs/mfs_balloc.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -88,4 +88,11 @@
 {
 	int r = mfs_alloc_bit(inst, zone, BMAP_ZONE);
+	if (r != EOK)
+		return r;
+
+	/* Update the cached number of free zones */
+	struct mfs_sb_info *sbi = inst->sbi;
+	if (sbi->nfree_zones_valid)
+		sbi->nfree_zones--;
 
 	*zone += inst->sbi->firstdatazone - 1;
@@ -103,7 +110,18 @@
 mfs_free_zone(struct mfs_instance *inst, uint32_t zone)
 {
+	int r;
+
 	zone -= inst->sbi->firstdatazone - 1;
 
-	return mfs_free_bit(inst, zone, BMAP_ZONE);
+	r = mfs_free_bit(inst, zone, BMAP_ZONE);
+	if (r != EOK)
+		return r;
+
+	/* Update the cached number of free zones */
+	struct mfs_sb_info *sbi = inst->sbi;
+	if (sbi->nfree_zones_valid)
+		sbi->nfree_zones++;
+
+	return r;
 }
 
Index: uspace/srv/fs/mfs/mfs_ops.c
===================================================================
--- uspace/srv/fs/mfs/mfs_ops.c	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ uspace/srv/fs/mfs/mfs_ops.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -216,4 +216,6 @@
 	sbi->isearch = 0;
 	sbi->zsearch = 0;
+	sbi->nfree_zones_valid = false;
+	sbi->nfree_zones = 0;
 
 	if (version == MFS_VERSION_V3) {
@@ -1181,11 +1183,23 @@
 		return rc;
 
-	if (NULL == inst)
-		return ENOENT;
-
-	mfs_count_free_zones(inst, &block_free);
-	*count = block_free;
-
-	return EOK;
+	struct mfs_sb_info *sbi = inst->sbi;
+
+	if (!sbi->nfree_zones_valid) {
+		/* The cached number of free zones is not valid,
+		 * we need to scan the bitmap to retrieve the
+		 * current value.
+		 */
+
+		rc = mfs_count_free_zones(inst, &block_free);
+		if (rc != EOK)
+			return rc;
+
+		sbi->nfree_zones = block_free;
+		sbi->nfree_zones_valid = true;
+	}
+
+	*count = sbi->nfree_zones;
+
+	return rc;
 }
 
Index: uspace/srv/hid/compositor/compositor.c
===================================================================
--- uspace/srv/hid/compositor/compositor.c	(revision 947e2ef52b4d89628cb7e4dc1fec8ca166910b10)
+++ uspace/srv/hid/compositor/compositor.c	(revision b9f7848b5b183be4b67751ef810198d86022cc26)
@@ -2176,5 +2176,5 @@
 	
 	/* Color of the viewport background. Must be opaque. */
-	bg_color = PIXEL(255, 75, 70, 75);
+	bg_color = PIXEL(255, 69, 51, 103);
 	
 	/* Register compositor server. */
